Hex Artifact Content

Artifact 9552d0e0341950e123e80276960920ed0772ea5f:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 53 65 74 20 74 69 6d 65  bash..# Set time
0020: 7a 6f 6e 65 20 74 6f 20 64 65 66 61 75 6c 74 0a  zone to default.
0030: 54 5a 3d 55 54 43 0a 65 78 70 6f 72 74 20 54 5a  TZ=UTC.export TZ
0040: 0a 0a 74 61 72 67 65 74 6d 6f 64 65 3d 27 69 6e  ..targetmode='in
0050: 73 74 61 6c 6c 27 0a 69 66 20 5b 20 22 24 31 22  stall'.if [ "$1"
0060: 20 3d 3d 20 27 2d 2d 63 70 69 6f 27 20 5d 3b 20   == '--cpio' ]; 
0070: 74 68 65 6e 0a 09 74 61 72 67 65 74 6d 6f 64 65  then..targetmode
0080: 3d 27 61 72 63 68 69 76 65 27 0a 0a 09 73 68 69  ='archive'...shi
0090: 66 74 0a 66 69 0a 0a 70 6b 67 3d 22 24 28 65 63  ft.fi..pkg="$(ec
00a0: 68 6f 20 22 24 31 22 20 7c 20 73 65 64 20 27 73  ho "$1" | sed 's
00b0: 40 2f 2a 24 40 40 3b 73 40 5e 5c 2e 2a 2f 2a 40  @/*$@@;s@^\.*/*@
00c0: 40 27 29 22 0a 0a 69 66 20 5b 20 2d 7a 20 22 24  @')"..if [ -z "$
00d0: 7b 70 6b 67 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {pkg}" ]; then..
00e0: 65 63 68 6f 20 22 55 73 61 67 65 3a 20 62 75 69  echo "Usage: bui
00f0: 6c 64 20 5b 2d 2d 63 70 69 6f 5d 20 3c 70 61 63  ld [--cpio] <pac
0100: 6b 61 67 65 3e 22 20 32 3e 26 31 0a 0a 09 65 78  kage>" 2>&1...ex
0110: 69 74 20 31 0a 66 69 0a 0a 66 75 6e 63 74 69 6f  it 1.fi..functio
0120: 6e 20 64 6f 77 6e 6c 6f 61 64 28 29 20 7b 0a 09  n download() {..
0130: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
0140: 61 72 63 68 69 76 65 7d 22 20 5d 3b 20 74 68 65  archive}" ]; the
0150: 6e 0a 09 09 23 20 44 6f 77 6e 6c 6f 61 64 0a 09  n...# Download..
0160: 09 23 23 20 43 6c 65 61 6e 75 70 0a 09 09 72 6d  .## Cleanup...rm
0170: 20 2d 66 20 73 72 63 2e 6e 65 77 0a 0a 09 09 23   -f src.new....#
0180: 23 20 46 65 74 63 68 20 66 69 6c 65 0a 09 09 77  # Fetch file...w
0190: 67 65 74 20 2d 4f 20 73 72 63 2e 6e 65 77 20 22  get -O src.new "
01a0: 24 7b 75 72 6c 7d 22 20 7c 7c 20 65 78 69 74 20  ${url}" || exit 
01b0: 31 0a 0a 09 09 23 23 20 56 65 72 69 66 79 20 73  1....## Verify s
01c0: 69 67 6e 61 74 75 72 65 0a 09 09 73 72 63 5f 73  ignature...src_s
01d0: 68 61 32 35 36 3d 22 24 28 6f 70 65 6e 73 73 6c  ha256="$(openssl
01e0: 20 73 68 61 32 35 36 20 27 73 72 63 2e 6e 65 77   sha256 'src.new
01f0: 27 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 3d 20  ' | sed 's@^.*= 
0200: 40 40 27 29 22 0a 09 09 69 66 20 5b 20 22 24 7b  @@')"...if [ "${
0210: 73 72 63 5f 73 68 61 32 35 36 7d 22 20 21 3d 20  src_sha256}" != 
0220: 22 24 7b 73 68 61 32 35 36 7d 22 20 5d 3b 20 74  "${sha256}" ]; t
0230: 68 65 6e 0a 09 09 09 65 63 68 6f 20 22 53 48 41  hen....echo "SHA
0240: 32 35 36 20 6d 69 73 6d 61 74 63 68 3a 20 20 44  256 mismatch:  D
0250: 6f 77 6e 6c 6f 61 64 65 64 3a 20 24 7b 73 72 63  ownloaded: ${src
0260: 5f 73 68 61 32 35 36 7d 20 21 3d 20 45 78 70 65  _sha256} != Expe
0270: 63 74 65 64 3a 20 24 7b 73 68 61 32 35 36 7d 22  cted: ${sha256}"
0280: 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20 31 0a   >&2.....exit 1.
0290: 09 09 66 69 0a 0a 09 09 23 23 20 4d 6f 76 65 20  ..fi....## Move 
02a0: 66 69 6c 65 20 69 6e 74 6f 20 70 6c 61 63 65 0a  file into place.
02b0: 09 09 6d 76 20 73 72 63 2e 6e 65 77 20 22 24 7b  ..mv src.new "${
02c0: 70 6b 67 61 72 63 68 69 76 65 7d 22 0a 09 66 69  pkgarchive}"..fi
02d0: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 65 78 74  .}..function ext
02e0: 72 61 63 74 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  ract() {..local 
02f0: 64 65 63 6f 6d 70 72 65 73 73 0a 0a 09 23 20 44  decompress...# D
0300: 65 63 6f 6d 70 72 65 73 73 20 61 72 63 68 69 76  ecompress archiv
0310: 65 0a 09 23 23 20 44 65 74 65 72 6d 69 6e 65 20  e..## Determine 
0320: 74 79 70 65 20 6f 66 20 61 72 63 68 69 76 65 0a  type of archive.
0330: 09 63 61 73 65 20 22 24 7b 75 72 6c 7d 22 20 69  .case "${url}" i
0340: 6e 0a 09 09 2a 2e 74 61 72 2e 78 7a 7c 2a 2e 74  n...*.tar.xz|*.t
0350: 61 72 2e 78 7a 27 3f 27 2a 7c 2a 2e 74 78 7a 29  ar.xz'?'*|*.txz)
0360: 0a 09 09 09 64 65 63 6f 6d 70 72 65 73 73 3d 27  ....decompress='
0370: 78 7a 27 0a 09 09 09 3b 3b 0a 09 09 2a 2e 74 61  xz'....;;...*.ta
0380: 72 2e 67 7a 7c 2a 2e 74 61 72 2e 67 7a 27 3f 27  r.gz|*.tar.gz'?'
0390: 2a 7c 2a 2e 74 67 7a 29 0a 09 09 09 64 65 63 6f  *|*.tgz)....deco
03a0: 6d 70 72 65 73 73 3d 27 67 7a 69 70 27 0a 09 09  mpress='gzip'...
03b0: 09 3b 3b 0a 09 09 2a 2e 74 61 72 2e 62 7a 32 7c  .;;...*.tar.bz2|
03c0: 2a 2e 74 61 72 2e 62 7a 32 27 3f 27 2a 7c 2a 2e  *.tar.bz2'?'*|*.
03d0: 74 62 7a 32 29 0a 09 09 09 64 65 63 6f 6d 70 72  tbz2)....decompr
03e0: 65 73 73 3d 27 62 7a 69 70 32 27 0a 09 09 09 3b  ess='bzip2'....;
03f0: 3b 0a 09 09 2a 2e 7a 69 70 7c 2a 2e 7a 69 70 27  ;...*.zip|*.zip'
0400: 3f 27 2a 29 0a 09 09 09 64 65 63 6f 6d 70 72 65  ?'*)....decompre
0410: 73 73 3d 27 75 6e 7a 69 70 27 0a 09 09 09 3b 3b  ss='unzip'....;;
0420: 0a 09 09 2a 29 0a 09 09 09 65 63 68 6f 20 22 55  ...*)....echo "U
0430: 6e 6b 6e 6f 77 6e 20 63 6f 6d 70 72 65 73 73 69  nknown compressi
0440: 6f 6e 20 6d 65 74 68 6f 64 3a 20 24 7b 75 72 6c  on method: ${url
0450: 7d 22 20 3e 26 32 0a 0a 09 09 09 65 78 69 74 20  }" >&2.....exit 
0460: 31 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 0a 09  1....;;..esac...
0470: 23 23 20 44 6f 20 64 65 63 6f 6d 70 72 65 73 73  ## Do decompress
0480: 69 6f 6e 0a 09 63 61 73 65 20 22 24 7b 64 65 63  ion..case "${dec
0490: 6f 6d 70 72 65 73 73 7d 22 20 69 6e 0a 09 09 75  ompress}" in...u
04a0: 6e 7a 69 70 29 0a 09 09 09 75 6e 7a 69 70 20 22  nzip)....unzip "
04b0: 24 7b 70 6b 67 61 72 63 68 69 76 65 7d 22 20 7c  ${pkgarchive}" |
04c0: 7c 20 64 69 65 20 27 55 6e 61 62 6c 65 20 74 6f  | die 'Unable to
04d0: 20 75 6e 63 6f 6d 70 72 65 73 73 20 61 72 63 68   uncompress arch
04e0: 69 76 65 27 0a 09 09 09 3b 3b 0a 09 09 2a 29 0a  ive'....;;...*).
04f0: 09 09 09 22 24 7b 64 65 63 6f 6d 70 72 65 73 73  ..."${decompress
0500: 7d 22 20 2d 64 63 20 22 24 7b 70 6b 67 61 72 63  }" -dc "${pkgarc
0510: 68 69 76 65 7d 22 20 7c 20 74 61 72 20 2d 78 66  hive}" | tar -xf
0520: 20 2d 20 7c 7c 20 64 69 65 20 27 55 6e 61 62 6c   - || die 'Unabl
0530: 65 20 74 6f 20 75 6e 63 6f 6d 70 72 65 73 73 20  e to uncompress 
0540: 61 72 63 68 69 76 65 27 0a 09 09 09 3b 3b 0a 09  archive'....;;..
0550: 65 73 61 63 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  esac.}..function
0560: 20 76 65 72 69 66 79 52 65 71 75 69 72 65 64 50   verifyRequiredP
0570: 61 63 6b 61 67 65 73 28 29 20 7b 0a 09 6c 6f 63  ackages() {..loc
0580: 61 6c 20 70 6b 67 20 70 6b 67 64 6f 6d 61 69 6e  al pkg pkgdomain
0590: 20 70 6b 67 76 65 72 73 69 6f 6e 0a 09 6c 6f 63   pkgversion..loc
05a0: 61 6c 20 70 6b 67 64 69 72 20 70 6b 67 63 6f 6e  al pkgdir pkgcon
05b0: 66 69 67 64 69 72 20 70 6b 67 66 6f 75 6e 64 0a  figdir pkgfound.
05c0: 0a 09 66 6f 72 20 70 6b 67 20 69 6e 20 22 24 7b  ..for pkg in "${
05d0: 72 65 71 75 69 72 65 5b 40 5d 7d 22 3b 20 64 6f  require[@]}"; do
05e0: 0a 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 27 27 0a  ...pkgdomain=''.
05f0: 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 27 27 0a  ..pkgversion=''.
0600: 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 43 46  ..pkgchanges=(CF
0610: 4c 41 47 53 20 4c 44 46 4c 41 47 53 20 50 41 54  LAGS LDFLAGS PAT
0620: 48 20 50 4b 47 5f 43 4f 4e 46 49 47 5f 50 41 54  H PKG_CONFIG_PAT
0630: 48 29 0a 0a 09 09 63 61 73 65 20 22 24 7b 70 6b  H)....case "${pk
0640: 67 7d 22 20 69 6e 0a 09 09 09 2a 3a 2a 29 0a 09  g}" in....*:*)..
0650: 09 09 09 70 6b 67 63 68 61 6e 67 65 73 3d 28 24  ...pkgchanges=($
0660: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0670: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 3a 27   cut -f 2 -d ':'
0680: 29 29 0a 09 09 09 09 70 6b 67 3d 22 24 28 65 63  )).....pkg="$(ec
0690: 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75  ho "${pkg}" | cu
06a0: 74 20 2d 66 20 31 20 2d 64 20 27 3a 27 29 22 0a  t -f 1 -d ':')".
06b0: 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09  ....;;...esac...
06c0: 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22 20 69  .case "${pkg}" i
06d0: 6e 0a 09 09 09 2a 2f 2a 40 2a 29 0a 09 09 09 09  n....*/*@*).....
06e0: 70 6b 67 64 6f 6d 61 69 6e 3d 22 24 28 65 63 68  pkgdomain="$(ech
06f0: 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63 75 74  o "${pkg}" | cut
0700: 20 2d 66 20 32 20 2d 64 20 27 40 27 29 22 0a 09   -f 2 -d '@')"..
0710: 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d 22 24  ...pkgversion="$
0720: 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c  (echo "${pkg}" |
0730: 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 2f 27   cut -f 2 -d '/'
0740: 20 7c 20 63 75 74 20 2d 66 20 31 20 2d 64 20 27   | cut -f 1 -d '
0750: 40 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  @')".....pkg="$(
0760: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
0770: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
0780: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2f 2a 29  ".....;;....*/*)
0790: 0a 09 09 09 09 70 6b 67 76 65 72 73 69 6f 6e 3d  .....pkgversion=
07a0: 22 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22  "$(echo "${pkg}"
07b0: 20 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27   | cut -f 2 -d '
07c0: 2f 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28  /')".....pkg="$(
07d0: 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20  echo "${pkg}" | 
07e0: 63 75 74 20 2d 66 20 31 20 2d 64 20 27 2f 27 29  cut -f 1 -d '/')
07f0: 22 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 40 2a 29  ".....;;....*@*)
0800: 0a 09 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22  .....pkgdomain="
0810: 24 28 65 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20  $(echo "${pkg}" 
0820: 7c 20 63 75 74 20 2d 66 20 32 20 2d 64 20 27 40  | cut -f 2 -d '@
0830: 27 29 22 0a 09 09 09 09 70 6b 67 3d 22 24 28 65  ')".....pkg="$(e
0840: 63 68 6f 20 22 24 7b 70 6b 67 7d 22 20 7c 20 63  cho "${pkg}" | c
0850: 75 74 20 2d 66 20 31 20 2d 64 20 27 40 27 29 22  ut -f 1 -d '@')"
0860: 0a 09 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a  .....;;...esac..
0870: 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 70 6b 67  ..if [ -z "${pkg
0880: 64 6f 6d 61 69 6e 7d 22 20 5d 3b 20 74 68 65 6e  domain}" ]; then
0890: 0a 09 09 09 70 6b 67 64 6f 6d 61 69 6e 3d 22 24  ....pkgdomain="$
08a0: 7b 64 6f 6d 61 69 6e 7d 22 0a 09 09 66 69 0a 0a  {domain}"...fi..
08b0: 09 09 70 6b 67 66 6f 75 6e 64 3d 27 30 27 0a 09  ..pkgfound='0'..
08c0: 09 66 6f 72 20 70 6b 67 64 69 72 20 69 6e 20 22  .for pkgdir in "
08d0: 2f 6f 70 74 2f 61 70 70 66 73 2f 24 7b 70 6b 67  /opt/appfs/${pkg
08e0: 64 6f 6d 61 69 6e 7d 2f 24 7b 70 6b 67 7d 2f 70  domain}/${pkg}/p
08f0: 6c 61 74 66 6f 72 6d 22 2f 24 7b 70 6b 67 76 65  latform"/${pkgve
0900: 72 73 69 6f 6e 3a 2d 2a 7d 3b 20 64 6f 0a 09 09  rsion:-*}; do...
0910: 09 70 6b 67 63 6f 6e 66 69 67 64 69 72 3d 22 24  .pkgconfigdir="$
0920: 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 2f 70 6b 67  {pkgdir}/lib/pkg
0930: 63 6f 6e 66 69 67 22 0a 0a 09 09 09 69 66 20 5b  config".....if [
0940: 20 2d 64 20 22 24 7b 70 6b 67 64 69 72 7d 22 20   -d "${pkgdir}" 
0950: 5d 3b 20 74 68 65 6e 0a 09 09 09 09 70 6b 67 66  ]; then.....pkgf
0960: 6f 75 6e 64 3d 27 31 27 0a 09 09 09 66 69 0a 0a  ound='1'....fi..
0970: 09 09 09 66 6f 72 20 70 6b 67 63 68 61 6e 67 65  ...for pkgchange
0980: 20 69 6e 20 22 24 7b 70 6b 67 63 68 61 6e 67 65   in "${pkgchange
0990: 73 5b 40 5d 7d 22 3b 20 64 6f 0a 09 09 09 09 63  s[@]}"; do.....c
09a0: 61 73 65 20 22 24 7b 70 6b 67 63 68 61 6e 67 65  ase "${pkgchange
09b0: 7d 22 20 69 6e 0a 09 09 09 09 09 43 46 4c 41 47  }" in......CFLAG
09c0: 53 29 0a 09 09 09 09 09 09 43 46 4c 41 47 53 3d  S).......CFLAGS=
09d0: 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49 24 7b 70  "${CFLAGS} -I${p
09e0: 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a  kgdir}/include".
09f0: 09 09 09 09 09 09 43 50 50 46 4c 41 47 53 3d 22  ......CPPFLAGS="
0a00: 24 7b 43 50 50 46 4c 41 47 53 7d 20 2d 49 24 7b  ${CPPFLAGS} -I${
0a10: 70 6b 67 64 69 72 7d 2f 69 6e 63 6c 75 64 65 22  pkgdir}/include"
0a20: 0a 09 09 09 09 09 09 65 78 70 6f 72 74 20 43 46  .......export CF
0a30: 4c 41 47 53 20 43 50 50 46 4c 41 47 53 0a 09 09  LAGS CPPFLAGS...
0a40: 09 09 09 09 3b 3b 0a 09 09 09 09 09 4c 44 46 4c  ....;;......LDFL
0a50: 41 47 53 29 0a 09 09 09 09 09 09 4c 44 46 4c 41  AGS).......LDFLA
0a60: 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 2d  GS="${LDFLAGS} -
0a70: 4c 24 7b 70 6b 67 64 69 72 7d 2f 6c 69 62 20 2d  L${pkgdir}/lib -
0a80: 57 6c 2c 2d 72 70 61 74 68 2c 24 7b 70 6b 67 64  Wl,-rpath,${pkgd
0a90: 69 72 7d 2f 6c 69 62 22 0a 09 09 09 09 09 09 65  ir}/lib".......e
0aa0: 78 70 6f 72 74 20 4c 44 46 4c 41 47 53 0a 09 09  xport LDFLAGS...
0ab0: 09 09 09 09 3b 3b 0a 09 09 09 09 09 50 41 54 48  ....;;......PATH
0ac0: 29 0a 09 09 09 09 09 09 50 41 54 48 3d 22 24 7b  ).......PATH="${
0ad0: 50 41 54 48 7d 3a 24 7b 70 6b 67 64 69 72 7d 2f  PATH}:${pkgdir}/
0ae0: 62 69 6e 22 0a 09 09 09 09 09 09 65 78 70 6f 72  bin".......expor
0af0: 74 20 50 41 54 48 0a 09 09 09 09 09 09 3b 3b 0a  t PATH.......;;.
0b00: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b10: 50 41 54 48 29 0a 09 09 09 09 09 09 69 66 20 5b  PATH).......if [
0b20: 20 2d 64 20 22 24 7b 70 6b 67 63 6f 6e 66 69 67   -d "${pkgconfig
0b30: 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  dir}" ]; then...
0b40: 09 09 09 09 09 50 4b 47 5f 43 4f 4e 46 49 47 5f  .....PKG_CONFIG_
0b50: 50 41 54 48 3d 22 24 7b 50 4b 47 5f 43 4f 4e 46  PATH="${PKG_CONF
0b60: 49 47 5f 50 41 54 48 7d 3a 24 7b 70 6b 67 63 6f  IG_PATH}:${pkgco
0b70: 6e 66 69 67 64 69 72 7d 22 0a 09 09 09 09 09 09  nfigdir}".......
0b80: 09 65 78 70 6f 72 74 20 50 4b 47 5f 43 4f 4e 46  .export PKG_CONF
0b90: 49 47 5f 50 41 54 48 0a 09 09 09 09 09 09 66 69  IG_PATH.......fi
0ba0: 0a 09 09 09 09 09 09 3b 3b 0a 09 09 09 09 65 73  .......;;.....es
0bb0: 61 63 0a 09 09 09 64 6f 6e 65 0a 09 09 64 6f 6e  ac....done...don
0bc0: 65 0a 0a 09 09 69 66 20 5b 20 22 24 7b 70 6b 67  e....if [ "${pkg
0bd0: 66 6f 75 6e 64 7d 22 20 3d 20 27 30 27 20 5d 3b  found}" = '0' ];
0be0: 20 74 68 65 6e 0a 09 09 09 64 69 65 20 22 50 61   then....die "Pa
0bf0: 63 6b 61 67 65 20 24 7b 70 6b 67 7d 2f 24 7b 70  ckage ${pkg}/${p
0c00: 6b 67 76 65 72 73 69 6f 6e 3a 2d 2a 7d 40 24 7b  kgversion:-*}@${
0c10: 70 6b 67 64 6f 6d 61 69 6e 7d 20 6e 6f 74 20 66  pkgdomain} not f
0c20: 6f 75 6e 64 2e 22 0a 09 09 66 69 0a 09 64 6f 6e  ound."...fi..don
0c30: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 76 65  e.}..function ve
0c40: 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74 65  rifyPrerequisite
0c50: 73 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75 6e 63  s() {..:.}..func
0c60: 74 69 6f 6e 20 64 65 74 65 72 6d 69 6e 65 4f 73  tion determineOs
0c70: 41 72 63 68 28 29 20 7b 0a 09 6f 73 3d 22 24 28  Arch() {..os="$(
0c80: 75 6e 61 6d 65 20 2d 73 20 7c 20 64 64 20 63 6f  uname -s | dd co
0c90: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0ca0: 6e 75 6c 6c 29 22 0a 09 61 72 63 68 3d 22 24 28  null)"..arch="$(
0cb0: 75 6e 61 6d 65 20 2d 6d 20 7c 20 64 64 20 63 6f  uname -m | dd co
0cc0: 6e 76 3d 6c 63 61 73 65 20 32 3e 2f 64 65 76 2f  nv=lcase 2>/dev/
0cd0: 6e 75 6c 6c 29 22 0a 0a 09 63 61 73 65 20 22 24  null)"...case "$
0ce0: 7b 61 72 63 68 7d 22 20 69 6e 0a 09 09 69 3f 38  {arch}" in...i?8
0cf0: 36 29 0a 09 09 09 61 72 63 68 3d 27 69 78 38 36  6)....arch='ix86
0d00: 27 0a 09 09 09 3b 3b 0a 09 65 73 61 63 0a 7d 0a  '....;;..esac.}.
0d10: 0a 66 75 6e 63 74 69 6f 6e 20 64 65 74 65 72 6d  .function determ
0d20: 69 6e 65 50 72 65 66 69 78 28 29 20 7b 0a 09 64  inePrefix() {..d
0d30: 65 74 65 72 6d 69 6e 65 4f 73 41 72 63 68 0a 0a  etermineOsArch..
0d40: 09 70 72 65 66 69 78 73 75 66 66 69 78 3d 22 24  .prefixsuffix="$
0d50: 7b 70 6b 67 7d 2f 24 7b 6f 73 7d 2d 24 7b 61 72  {pkg}/${os}-${ar
0d60: 63 68 7d 2f 24 7b 76 65 72 73 69 6f 6e 7d 22 0a  ch}/${version}".
0d70: 09 70 72 65 66 69 78 3d 22 2f 6f 70 74 2f 61 70  .prefix="/opt/ap
0d80: 70 66 73 2f 24 7b 64 6f 6d 61 69 6e 7d 2f 24 7b  pfs/${domain}/${
0d90: 70 72 65 66 69 78 73 75 66 66 69 78 7d 22 0a 09  prefixsuffix}"..
0da0: 64 65 73 74 64 69 72 3d 22 24 28 70 77 64 29 2f  destdir="$(pwd)/
0db0: 49 4e 53 54 22 0a 0a 09 6d 6b 64 69 72 20 22 24  INST"...mkdir "$
0dc0: 7b 64 65 73 74 64 69 72 7d 22 20 7c 7c 20 64 69  {destdir}" || di
0dd0: 65 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 72  e.}..function pr
0de0: 65 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a 09  econfigure() {..
0df0: 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f  :.}..function po
0e00: 73 74 63 6f 6e 66 69 67 75 72 65 28 29 20 7b 0a  stconfigure() {.
0e10: 09 3a 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 63  .:.}..function c
0e20: 6f 6e 66 69 67 75 72 65 5f 67 63 63 28 29 20 7b  onfigure_gcc() {
0e30: 0a 09 6c 6f 63 61 6c 20 67 6c 69 62 63 64 69 72  ..local glibcdir
0e40: 20 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69 72   linuxheadersdir
0e50: 0a 09 6c 6f 63 61 6c 20 64 79 6e 6c 69 6e 6b 65  ..local dynlinke
0e60: 72 0a 09 6c 6f 63 61 6c 20 67 63 63 5f 64 65 66  r..local gcc_def
0e70: 61 75 6c 74 5f 68 65 61 64 65 72 73 0a 0a 09 67  ault_headers...g
0e80: 6c 69 62 63 64 69 72 3d 22 2f 6f 70 74 2f 61 70  libcdir="/opt/ap
0e90: 70 66 73 2f 63 6f 72 65 2e 61 70 70 66 73 2e 72  pfs/core.appfs.r
0ea0: 6b 65 65 6e 65 2e 6f 72 67 2f 67 6c 69 62 63 2f  keene.org/glibc/
0eb0: 70 6c 61 74 66 6f 72 6d 2f 6c 61 74 65 73 74 22  platform/latest"
0ec0: 0a 09 67 6c 69 62 63 64 69 72 3d 22 24 28 72 65  ..glibcdir="$(re
0ed0: 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b 67 6c 69  adlink -f "${gli
0ee0: 62 63 64 69 72 7d 22 29 22 0a 0a 09 6c 69 6e 75  bcdir}")"...linu
0ef0: 78 68 65 61 64 65 72 73 64 69 72 3d 22 2f 6f 70  xheadersdir="/op
0f00: 74 2f 61 70 70 66 73 2f 63 6f 72 65 2e 61 70 70  t/appfs/core.app
0f10: 66 73 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 6c 69  fs.rkeene.org/li
0f20: 6e 75 78 2d 68 65 61 64 65 72 73 2f 70 6c 61 74  nux-headers/plat
0f30: 66 6f 72 6d 2f 6c 61 74 65 73 74 22 0a 09 6c 69  form/latest"..li
0f40: 6e 75 78 68 65 61 64 65 72 73 64 69 72 3d 22 24  nuxheadersdir="$
0f50: 28 72 65 61 64 6c 69 6e 6b 20 2d 66 20 22 24 7b  (readlink -f "${
0f60: 6c 69 6e 75 78 68 65 61 64 65 72 73 64 69 72 7d  linuxheadersdir}
0f70: 22 29 22 0a 0a 09 64 79 6e 6c 69 6e 6b 65 72 3d  ")"...dynlinker=
0f80: 22 24 28 6c 73 20 22 24 7b 67 6c 69 62 63 64 69  "$(ls "${glibcdi
0f90: 72 7d 22 2f 6c 69 62 2f 6c 64 2d 6c 69 6e 75 78  r}"/lib/ld-linux
0fa0: 2a 2e 73 6f 2e 2a 20 7c 20 74 61 69 6c 20 2d 6e  *.so.* | tail -n
0fb0: 20 31 29 22 0a 0a 09 69 66 20 5b 20 21 20 2d 66   1)"...if [ ! -f
0fc0: 20 22 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d 22 20   "${dynlinker}" 
0fd0: 5d 3b 20 74 68 65 6e 0a 09 09 64 69 65 20 27 67  ]; then...die 'g
0fe0: 6c 69 62 63 20 64 69 72 65 63 74 6f 72 79 20 69  libc directory i
0ff0: 73 20 6e 6f 74 20 61 76 61 69 6c 61 62 6c 65 20  s not available 
1000: 28 61 70 70 66 73 20 72 75 6e 6e 69 6e 67 2f 77  (appfs running/w
1010: 6f 72 6b 69 6e 67 3f 29 27 0a 09 66 69 0a 0a 09  orking?)'..fi...
1020: 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65 61 64  gcc_default_head
1030: 65 72 73 3d 22 24 28 65 63 68 6f 20 27 27 20 7c  ers="$(echo '' |
1040: 20 24 7b 43 50 50 3a 2d 63 70 70 7d 20 2d 76 20   ${CPP:-cpp} -v 
1050: 32 3e 26 31 20 7c 20 73 65 64 20 27 2f 5e 45 6e  2>&1 | sed '/^En
1060: 64 20 6f 66 20 73 65 61 72 63 68 20 6c 69 73 74  d of search list
1070: 2f 2c 24 20 64 3b 30 2c 2f 73 65 61 72 63 68 20  /,$ d;0,/search 
1080: 73 74 61 72 74 73 20 68 65 72 65 3a 24 2f 20 64  starts here:$/ d
1090: 27 20 7c 20 67 72 65 70 20 27 2f 67 63 63 2f 27  ' | grep '/gcc/'
10a0: 20 7c 20 73 65 64 20 27 73 40 5e 20 2a 40 2d 49   | sed 's@^ *@-I
10b0: 40 27 20 7c 20 74 72 20 24 27 5c 6e 27 20 27 20  @' | tr $'\n' ' 
10c0: 27 29 22 0a 0a 09 43 43 3d 22 24 7b 43 43 3a 2d  ')"...CC="${CC:-
10d0: 67 63 63 7d 20 2d 6e 6f 73 74 64 69 6e 63 20 24  gcc} -nostdinc $
10e0: 7b 67 63 63 5f 64 65 66 61 75 6c 74 5f 68 65 61  {gcc_default_hea
10f0: 64 65 72 73 7d 20 2d 49 24 7b 67 6c 69 62 63 64  ders} -I${glibcd
1100: 69 72 7d 2f 69 6e 63 6c 75 64 65 22 0a 0a 09 69  ir}/include"...i
1110: 66 20 21 20 65 63 68 6f 20 22 20 24 7b 72 65 71  f ! echo " ${req
1120: 75 69 72 65 5b 2a 5d 7d 20 22 20 7c 20 67 72 65  uire[*]} " | gre
1130: 70 20 27 20 6c 69 6e 75 78 2d 68 65 61 64 65 72  p ' linux-header
1140: 73 5b 2f 40 3a 20 5d 27 20 3e 2f 64 65 76 2f 6e  s[/@: ]' >/dev/n
1150: 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 43 43 3d 22  ull; then...CC="
1160: 24 7b 43 43 7d 20 2d 49 24 7b 6c 69 6e 75 78 68  ${CC} -I${linuxh
1170: 65 61 64 65 72 73 64 69 72 7d 2f 69 6e 63 6c 75  eadersdir}/inclu
1180: 64 65 22 0a 09 66 69 0a 0a 09 42 55 49 4c 44 5f  de"..fi...BUILD_
1190: 43 43 3d 22 24 7b 43 43 7d 22 0a 09 48 4f 53 54  CC="${CC}"..HOST
11a0: 5f 43 43 3d 22 24 7b 43 43 7d 22 0a 09 4c 44 46  _CC="${CC}"..LDF
11b0: 4c 41 47 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d  LAGS="${LDFLAGS}
11c0: 20 2d 4c 24 7b 67 6c 69 62 63 64 69 72 7d 2f 6c   -L${glibcdir}/l
11d0: 69 62 20 2d 57 6c 2c 2d 2d 72 70 61 74 68 2c 24  ib -Wl,--rpath,$
11e0: 7b 67 6c 69 62 63 64 69 72 7d 2f 6c 69 62 20 2d  {glibcdir}/lib -
11f0: 57 6c 2c 2d 2d 64 79 6e 61 6d 69 63 2d 6c 69 6e  Wl,--dynamic-lin
1200: 6b 65 72 2c 24 7b 64 79 6e 6c 69 6e 6b 65 72 7d  ker,${dynlinker}
1210: 22 0a 09 50 4b 47 5f 43 4f 4e 46 49 47 5f 4c 49  "..PKG_CONFIG_LI
1220: 42 44 49 52 3d 22 24 7b 67 6c 69 62 63 64 69 72  BDIR="${glibcdir
1230: 7d 2f 6c 69 62 2f 70 6b 67 63 6f 6e 66 69 67 22  }/lib/pkgconfig"
1240: 0a 09 65 78 70 6f 72 74 20 43 43 20 42 55 49 4c  ..export CC BUIL
1250: 44 5f 43 43 20 48 4f 53 54 5f 43 43 20 4c 44 46  D_CC HOST_CC LDF
1260: 4c 41 47 53 20 50 4b 47 5f 43 4f 4e 46 49 47 5f  LAGS PKG_CONFIG_
1270: 4c 49 42 44 49 52 0a 7d 0a 0a 66 75 6e 63 74 69  LIBDIR.}..functi
1280: 6f 6e 20 63 6f 6e 66 69 67 75 72 65 28 29 20 7b  on configure() {
1290: 0a 09 63 6f 6e 66 69 67 75 72 65 5f 67 63 63 0a  ..configure_gcc.
12a0: 09 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d 2d 70  ../configure --p
12b0: 72 65 66 69 78 3d 22 24 7b 70 72 65 66 69 78 7d  refix="${prefix}
12c0: 22 20 2d 2d 73 79 73 63 6f 6e 66 64 69 72 3d 22  " --sysconfdir="
12d0: 24 7b 70 72 65 66 69 78 7d 2f 65 74 63 22 20 2d  ${prefix}/etc" -
12e0: 2d 6c 69 62 64 69 72 3d 22 24 7b 70 72 65 66 69  -libdir="${prefi
12f0: 78 7d 2f 6c 69 62 22 20 2d 2d 6c 6f 63 61 6c 73  x}/lib" --locals
1300: 74 61 74 65 64 69 72 3d 2f 76 61 72 20 22 24 7b  tatedir=/var "${
1310: 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61 5b  configure_extra[
1320: 40 5d 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e  @]}".}..function
1330: 20 70 72 65 62 75 69 6c 64 28 29 20 7b 0a 09 3a   prebuild() {..:
1340: 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 70 6f 73  .}..function pos
1350: 74 62 75 69 6c 64 28 29 20 7b 0a 09 3a 0a 7d 0a  tbuild() {..:.}.
1360: 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64 28  .function build(
1370: 29 20 7b 0a 09 67 72 65 70 20 22 44 45 53 54 44  ) {..grep "DESTD
1380: 49 52 22 20 4d 61 6b 65 66 69 6c 65 20 3e 2f 64  IR" Makefile >/d
1390: 65 76 2f 6e 75 6c 6c 20 7c 7c 20 64 69 65 20 22  ev/null || die "
13a0: 44 6f 6e 27 74 20 6b 6e 6f 77 20 68 6f 77 20 74  Don't know how t
13b0: 6f 20 62 75 69 6c 64 20 74 68 69 73 20 73 6f 66  o build this sof
13c0: 74 77 61 72 65 22 0a 0a 09 6d 61 6b 65 0a 7d 0a  tware"...make.}.
13d0: 0a 66 75 6e 63 74 69 6f 6e 20 70 72 65 69 6e 73  .function preins
13e0: 74 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66  tall() {..:.}..f
13f0: 75 6e 63 74 69 6f 6e 20 70 6f 73 74 69 6e 73 74  unction postinst
1400: 61 6c 6c 28 29 20 7b 0a 09 3a 0a 7d 0a 0a 66 75  all() {..:.}..fu
1410: 6e 63 74 69 6f 6e 20 69 6e 73 74 61 6c 6c 28 29  nction install()
1420: 20 7b 0a 09 6d 61 6b 65 20 69 6e 73 74 61 6c 6c   {..make install
1430: 20 44 45 53 54 44 49 52 3d 22 24 7b 64 65 73 74   DESTDIR="${dest
1440: 64 69 72 7d 22 0a 7d 0a 0a 66 75 6e 63 74 69 6f  dir}".}..functio
1450: 6e 20 63 6c 65 61 6e 75 70 28 29 20 7b 0a 09 63  n cleanup() {..c
1460: 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c  d "${workdir}" |
1470: 7c 20 65 78 69 74 20 31 0a 09 63 64 20 2e 2e 20  | exit 1..cd .. 
1480: 7c 7c 20 65 78 69 74 20 31 0a 09 72 6d 20 2d 72  || exit 1..rm -r
1490: 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 7d  f "${workdir}".}
14a0: 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 69 65 28 29  ..function die()
14b0: 20 7b 0a 09 6c 6f 63 61 6c 20 6d 65 73 73 61 67   {..local messag
14c0: 65 0a 0a 09 6d 65 73 73 61 67 65 3d 22 24 31 22  e...message="$1"
14d0: 0a 0a 09 69 66 20 5b 20 2d 6e 20 22 24 7b 6d 65  ...if [ -n "${me
14e0: 73 73 61 67 65 7d 22 20 5d 3b 20 74 68 65 6e 0a  ssage}" ]; then.
14f0: 09 09 65 63 68 6f 20 22 65 72 72 6f 72 3a 20 24  ..echo "error: $
1500: 7b 6d 65 73 73 61 67 65 7d 22 20 3e 26 32 0a 09  {message}" >&2..
1510: 66 69 0a 0a 09 65 78 69 74 20 31 0a 7d 0a 0a 73  fi...exit 1.}..s
1520: 63 72 69 70 74 64 69 72 3d 22 24 28 63 64 20 22  criptdir="$(cd "
1530: 24 28 64 69 72 6e 61 6d 65 20 22 24 28 77 68 69  $(dirname "$(whi
1540: 63 68 20 22 24 30 22 29 22 29 22 20 26 26 20 70  ch "$0")")" && p
1550: 77 64 29 22 0a 69 66 20 5b 20 2d 7a 20 22 24 7b  wd)".if [ -z "${
1560: 73 63 72 69 70 74 64 69 72 7d 22 20 5d 3b 20 74  scriptdir}" ]; t
1570: 68 65 6e 0a 09 65 63 68 6f 20 22 55 6e 61 62 6c  hen..echo "Unabl
1580: 65 20 74 6f 20 6c 6f 63 61 74 65 20 73 63 72 69  e to locate scri
1590: 70 74 20 64 69 72 65 63 74 6f 72 79 22 20 3e 26  pt directory" >&
15a0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 63  2...exit 1.fi..c
15b0: 64 20 22 24 7b 73 63 72 69 70 74 64 69 72 7d 22  d "${scriptdir}"
15c0: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 69 66 20 5b   || exit 1..if [
15d0: 20 2d 66 20 27 62 75 69 6c 64 2e 63 6f 6e 66 27   -f 'build.conf'
15e0: 20 5d 3b 20 74 68 65 6e 0a 09 2e 20 27 62 75 69   ]; then... 'bui
15f0: 6c 64 2e 63 6f 6e 66 27 0a 66 69 0a 0a 69 66 20  ld.conf'.fi..if 
1600: 5b 20 2d 64 20 22 70 6b 67 73 2f 24 7b 70 6b 67  [ -d "pkgs/${pkg
1610: 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67 64  }" ]; then..pkgd
1620: 69 72 3d 22 70 6b 67 73 2f 24 7b 70 6b 67 7d 22  ir="pkgs/${pkg}"
1630: 0a 09 70 6b 67 66 69 6c 65 3d 22 24 7b 70 6b 67  ..pkgfile="${pkg
1640: 64 69 72 7d 2f 69 6e 66 6f 22 0a 65 6c 73 65 0a  dir}/info".else.
1650: 09 70 6b 67 66 69 6c 65 3d 22 70 6b 67 73 2f 24  .pkgfile="pkgs/$
1660: 7b 70 6b 67 7d 22 0a 09 70 6b 67 64 69 72 3d 22  {pkg}"..pkgdir="
1670: 24 7b 70 6b 67 66 69 6c 65 7d 22 0a 66 69 0a 0a  ${pkgfile}".fi..
1680: 69 66 20 5b 20 21 20 2d 65 20 22 24 7b 70 6b 67  if [ ! -e "${pkg
1690: 66 69 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  file}" ]; then..
16a0: 65 63 68 6f 20 22 49 6e 76 61 6c 69 64 20 70 61  echo "Invalid pa
16b0: 63 6b 61 67 65 2e 22 20 3e 26 32 0a 0a 09 65 78  ckage." >&2...ex
16c0: 69 74 20 31 0a 66 69 0a 0a 70 6b 67 64 61 74 65  it 1.fi..pkgdate
16d0: 3d 22 24 28 66 6f 72 20 61 72 74 69 66 61 63 74  ="$(for artifact
16e0: 20 69 6e 20 24 28 66 69 6e 64 20 22 24 7b 70 6b   in $(find "${pk
16f0: 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66 20 2d  gdir}" -type f -
1700: 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20 2d  print0 | xargs -
1710: 6e 20 31 20 2d 30 20 66 6f 73 73 69 6c 20 66 69  n 1 -0 fossil fi
1720: 6e 66 6f 20 2d 2d 6c 69 6d 69 74 20 31 20 2d 2d  nfo --limit 1 --
1730: 77 69 64 74 68 20 30 20 32 3e 2f 64 65 76 2f 6e  width 0 2>/dev/n
1740: 75 6c 6c 20 7c 20 67 72 65 70 20 27 5e 5b 30 2d  ull | grep '^[0-
1750: 39 5d 5b 30 2d 39 5d 5b 30 2d 39 5d 5b 30 2d 39  9][0-9][0-9][0-9
1760: 5d 2d 5b 30 2d 39 5d 5b 30 2d 39 5d 2d 5b 30 2d  ]-[0-9][0-9]-[0-
1770: 39 5d 5b 30 2d 39 5d 20 27 20 7c 20 73 65 64 20  9][0-9] ' | sed 
1780: 27 73 40 5e 5b 5e 20 5d 2a 20 5c 5b 40 40 3b 73  's@^[^ ]* \[@@;s
1790: 40 5c 5d 2e 2a 40 40 27 20 7c 20 73 6f 72 74 20  @\].*@@' | sort 
17a0: 2d 75 29 3b 20 64 6f 20 66 6f 73 73 69 6c 20 69  -u); do fossil i
17b0: 6e 66 6f 20 22 24 7b 61 72 74 69 66 61 63 74 7d  nfo "${artifact}
17c0: 22 20 7c 20 61 77 6b 20 27 2f 5e 75 75 69 64 3a  " | awk '/^uuid:
17d0: 2f 7b 20 70 72 69 6e 74 20 24 33 20 24 34 20 7d  /{ print $3 $4 }
17e0: 27 20 7c 20 73 65 64 20 27 73 40 5b 2d 3a 5d 40  ' | sed 's@[-:]@
17f0: 40 67 3b 73 40 2e 2e 24 40 5c 2e 26 40 27 3b 20  @g;s@..$@\.&@'; 
1800: 64 6f 6e 65 20 7c 20 73 6f 72 74 20 2d 6e 20 7c  done | sort -n |
1810: 20 74 61 69 6c 20 2d 6e 20 31 29 22 0a 69 66 20   tail -n 1)".if 
1820: 5b 20 2d 7a 20 22 24 7b 70 6b 67 64 61 74 65 7d  [ -z "${pkgdate}
1830: 22 20 5d 3b 20 74 68 65 6e 0a 09 70 6b 67 64 61  " ]; then..pkgda
1840: 74 65 3d 22 24 28 66 69 6e 64 20 22 24 7b 70 6b  te="$(find "${pk
1850: 67 64 69 72 7d 22 20 2d 74 79 70 65 20 66 20 2d  gdir}" -type f -
1860: 70 72 69 6e 74 66 20 27 25 54 59 25 54 6d 25 54  printf '%TY%Tm%T
1870: 64 25 54 48 25 54 4d 2e 25 54 53 5c 6e 27 20 32  d%TH%TM.%TS\n' 2
1880: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 20 63 75 74  >/dev/null | cut
1890: 20 2d 66 20 31 2d 32 20 2d 64 20 27 2e 27 20 7c   -f 1-2 -d '.' |
18a0: 20 73 6f 72 74 20 2d 6e 20 7c 20 74 61 69 6c 20   sort -n | tail 
18b0: 2d 6e 20 31 29 22 0a 66 69 0a 0a 2e 20 22 24 7b  -n 1)".fi... "${
18c0: 70 6b 67 66 69 6c 65 7d 22 0a 0a 61 72 63 68 69  pkgfile}"..archi
18d0: 76 65 64 69 72 3d 22 24 28 70 77 64 29 2f 41 52  vedir="$(pwd)/AR
18e0: 43 48 49 56 45 22 0a 77 6f 72 6b 64 69 72 3d 22  CHIVE".workdir="
18f0: 77 6f 72 6b 64 69 72 2d 24 24 24 7b 52 41 4e 44  workdir-$$${RAND
1900: 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41  OM}${RANDOM}${RA
1910: 4e 44 4f 4d 7d 22 0a 70 6b 67 61 72 63 68 69 76  NDOM}".pkgarchiv
1920: 65 3d 22 24 7b 61 72 63 68 69 76 65 64 69 72 7d  e="${archivedir}
1930: 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f  /${pkg}-${versio
1940: 6e 7d 22 0a 6d 6b 64 69 72 20 22 24 7b 61 72 63  n}".mkdir "${arc
1950: 68 69 76 65 64 69 72 7d 22 20 3e 2f 64 65 76 2f  hivedir}" >/dev/
1960: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
1970: 0a 6d 6b 64 69 72 20 22 24 7b 77 6f 72 6b 64 69  .mkdir "${workdi
1980: 72 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 63 64  r}" || exit 1.cd
1990: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c   "${workdir}" ||
19a0: 20 65 78 69 74 20 31 0a 77 6f 72 6b 64 69 72 3d   exit 1.workdir=
19b0: 22 24 28 70 77 64 29 22 0a 0a 23 20 44 6f 77 6e  "$(pwd)"..# Down
19c0: 6c 6f 61 64 0a 64 6f 77 6e 6c 6f 61 64 0a 0a 23  load.download..#
19d0: 20 45 78 74 72 61 63 74 0a 65 78 74 72 61 63 74   Extract.extract
19e0: 0a 0a 23 20 49 66 20 77 65 20 6a 75 73 74 20 68  ..# If we just h
19f0: 61 76 65 20 6f 6e 65 20 64 69 72 65 63 74 6f 72  ave one director
1a00: 79 2c 20 75 73 65 20 74 68 61 74 20 64 69 72 65  y, use that dire
1a10: 63 74 6f 72 79 0a 64 69 72 3d 22 24 28 65 63 68  ctory.dir="$(ech
1a20: 6f 20 2a 29 22 0a 69 66 20 5b 20 2d 65 20 22 24  o *)".if [ -e "$
1a30: 7b 64 69 72 7d 22 20 5d 3b 20 74 68 65 6e 0a 09  {dir}" ]; then..
1a40: 6d 76 20 22 24 7b 64 69 72 7d 22 2f 2a 20 2e 0a  mv "${dir}"/* ..
1a50: 66 69 0a 0a 23 20 56 65 72 69 66 79 20 70 72 65  fi..# Verify pre
1a60: 2d 72 65 71 75 69 73 69 74 65 73 20 61 72 65 20  -requisites are 
1a70: 6d 65 74 0a 76 65 72 69 66 79 52 65 71 75 69 72  met.verifyRequir
1a80: 65 64 50 61 63 6b 61 67 65 73 20 7c 7c 20 64 69  edPackages || di
1a90: 65 20 27 52 65 71 75 69 72 65 64 20 70 61 63 6b  e 'Required pack
1aa0: 61 67 65 73 20 6d 69 73 73 69 6e 67 27 0a 76 65  ages missing'.ve
1ab0: 72 69 66 79 50 72 65 72 65 71 75 69 73 69 74 65  rifyPrerequisite
1ac0: 73 20 7c 7c 20 64 69 65 20 27 50 72 65 72 65 71  s || die 'Prereq
1ad0: 75 69 73 69 74 69 65 73 20 66 61 69 6c 65 64 27  uisities failed'
1ae0: 0a 0a 23 20 53 74 61 72 74 20 6c 6f 67 67 69 6e  ..# Start loggin
1af0: 67 0a 73 65 74 20 2d 78 0a 0a 23 20 44 65 74 65  g.set -x..# Dete
1b00: 72 6d 69 6e 65 20 70 72 6f 70 65 72 74 69 65 73  rmine properties
1b10: 0a 64 65 74 65 72 6d 69 6e 65 50 72 65 66 69 78  .determinePrefix
1b20: 0a 0a 23 20 53 74 61 72 74 20 74 68 65 20 62 75  ..# Start the bu
1b30: 69 6c 64 0a 70 72 65 63 6f 6e 66 69 67 75 72 65  ild.preconfigure
1b40: 20 7c 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66   || die 'preconf
1b50: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 63 6f  igure failed'.co
1b60: 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65 20 27  nfigure || die '
1b70: 63 6f 6e 66 69 67 75 72 65 20 66 61 69 6c 65 64  configure failed
1b80: 27 0a 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20  '.postconfigure 
1b90: 7c 7c 20 64 69 65 20 27 70 6f 73 74 63 6f 6e 66  || die 'postconf
1ba0: 69 67 75 72 65 20 66 61 69 6c 65 64 27 0a 0a 70  igure failed'..p
1bb0: 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  rebuild || die '
1bc0: 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27  prebuild failed'
1bd0: 0a 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 62  .build || die 'b
1be0: 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 70 6f 73  uild failed'.pos
1bf0: 74 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27 70  tbuild || die 'p
1c00: 6f 73 74 62 75 69 6c 64 20 66 61 69 6c 65 64 27  ostbuild failed'
1c10: 0a 0a 70 72 65 69 6e 73 74 61 6c 6c 20 7c 7c 20  ..preinstall || 
1c20: 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c 6c 20  die 'preinstall 
1c30: 66 61 69 6c 65 64 27 0a 69 6e 73 74 61 6c 6c 20  failed'.install 
1c40: 7c 7c 20 64 69 65 20 27 69 6e 73 74 61 6c 6c 20  || die 'install 
1c50: 66 61 69 6c 65 64 27 0a 70 6f 73 74 69 6e 73 74  failed'.postinst
1c60: 61 6c 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74  all || die 'post
1c70: 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a  install failed'.
1c80: 0a 28 0a 09 63 61 73 65 20 22 24 7b 74 61 72 67  .(..case "${targ
1c90: 65 74 6d 6f 64 65 7d 22 20 69 6e 0a 09 09 69 6e  etmode}" in...in
1ca0: 73 74 61 6c 6c 29 0a 09 09 09 61 70 70 64 69 72  stall)....appdir
1cb0: 3d 22 24 28 61 70 70 66 73 69 6e 73 74 61 6c 6c  ="$(appfsinstall
1cc0: 64 69 72 29 2f 24 7b 70 72 65 66 69 78 73 75 66  dir)/${prefixsuf
1cd0: 66 69 78 7d 22 0a 09 09 09 6d 6b 64 69 72 20 2d  fix}"....mkdir -
1ce0: 70 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 0a 09  p "${appdir}"...
1cf0: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
1d00: 2f 24 7b 70 72 65 66 69 78 7d 22 20 7c 7c 20 65  /${prefix}" || e
1d10: 78 69 74 20 31 0a 0a 09 09 09 63 70 20 2d 72 70  xit 1.....cp -rp
1d20: 20 2a 20 22 24 7b 61 70 70 64 69 72 7d 22 0a 09   * "${appdir}"..
1d30: 09 09 66 69 6e 64 20 22 24 7b 61 70 70 64 69 72  ..find "${appdir
1d40: 7d 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72  }" -print0 | xar
1d50: 67 73 20 2d 30 20 74 6f 75 63 68 20 2d 74 20 22  gs -0 touch -t "
1d60: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
1d70: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
1d80: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1d90: 2d 30 20 74 6f 75 63 68 20 2d 6d 20 2d 74 20 22  -0 touch -m -t "
1da0: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 66  ${pkgdate}"....f
1db0: 69 6e 64 20 22 24 7b 61 70 70 64 69 72 7d 22 20  ind "${appdir}" 
1dc0: 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67 73 20  -print0 | xargs 
1dd0: 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74 20 22  -0 touch -a -t "
1de0: 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09 09 3b  ${pkgdate}"....;
1df0: 3b 0a 09 09 61 72 63 68 69 76 65 29 0a 09 09 09  ;...archive)....
1e00: 61 72 63 68 69 76 65 66 69 6c 65 3d 22 24 7b 73  archivefile="${s
1e10: 63 72 69 70 74 64 69 72 7d 2f 24 7b 70 6b 67 7d  criptdir}/${pkg}
1e20: 2d 24 7b 76 65 72 73 69 6f 6e 7d 2d 24 28 65 63  -${version}-$(ec
1e30: 68 6f 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 20  ho "${pkgdate}" 
1e40: 7c 20 73 65 64 20 27 73 40 5c 2e 40 40 67 27 29  | sed 's@\.@@g')
1e50: 2d 24 7b 6f 73 7d 2d 24 7b 61 72 63 68 7d 2d 24  -${os}-${arch}-$
1e60: 7b 64 6f 6d 61 69 6e 7d 2e 63 70 69 6f 22 0a 09  {domain}.cpio"..
1e70: 09 09 63 64 20 22 24 7b 64 65 73 74 64 69 72 7d  ..cd "${destdir}
1e80: 2f 24 7b 70 72 65 66 69 78 7d 2f 2e 2e 2f 2e 2e  /${prefix}/../..
1e90: 2f 2e 2e 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  /.." || exit 1..
1ea0: 09 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78  ..find "${prefix
1eb0: 73 75 66 66 69 78 7d 22 20 2d 70 72 69 6e 74 30  suffix}" -print0
1ec0: 20 7c 20 78 61 72 67 73 20 2d 30 20 74 6f 75 63   | xargs -0 touc
1ed0: 68 20 2d 74 20 22 24 7b 70 6b 67 64 61 74 65 7d  h -t "${pkgdate}
1ee0: 22 0a 09 09 09 66 69 6e 64 20 22 24 7b 70 72 65  "....find "${pre
1ef0: 66 69 78 73 75 66 66 69 78 7d 22 20 2d 70 72 69  fixsuffix}" -pri
1f00: 6e 74 30 20 7c 20 78 61 72 67 73 20 2d 30 20 74  nt0 | xargs -0 t
1f10: 6f 75 63 68 20 2d 6d 20 2d 74 20 22 24 7b 70 6b  ouch -m -t "${pk
1f20: 67 64 61 74 65 7d 22 0a 09 09 09 66 69 6e 64 20  gdate}"....find 
1f30: 22 24 7b 70 72 65 66 69 78 73 75 66 66 69 78 7d  "${prefixsuffix}
1f40: 22 20 2d 70 72 69 6e 74 30 20 7c 20 78 61 72 67  " -print0 | xarg
1f50: 73 20 2d 30 20 74 6f 75 63 68 20 2d 61 20 2d 74  s -0 touch -a -t
1f60: 20 22 24 7b 70 6b 67 64 61 74 65 7d 22 0a 09 09   "${pkgdate}"...
1f70: 09 66 69 6e 64 20 22 24 7b 70 72 65 66 69 78 73  .find "${prefixs
1f80: 75 66 66 69 78 7d 22 20 7c 20 73 6f 72 74 20 7c  uffix}" | sort |
1f90: 20 63 70 69 6f 20 2d 2d 6f 77 6e 65 72 20 30 3a   cpio --owner 0:
1fa0: 30 20 2d 48 20 6e 65 77 63 20 2d 6f 20 3e 20 22  0 -H newc -o > "
1fb0: 24 7b 61 72 63 68 69 76 65 66 69 6c 65 7d 22 0a  ${archivefile}".
1fc0: 09 09 09 3b 3b 0a 09 65 73 61 63 0a 29 20 7c 7c  ...;;..esac.) ||
1fd0: 20 64 69 65 20 27 66 69 6e 61 6c 20 69 6e 73 74   die 'final inst
1fe0: 61 6c 6c 61 74 69 6f 6e 20 66 61 69 6c 65 64 27  allation failed'
1ff0: 0a 0a 63 6c 65 61 6e 75 70 0a 0a 65 78 69 74 20  ..cleanup..exit 
2000: 30 0a                                            0.